/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc/config/sh/sync.md:640 */
rtx
gen_atomic_exchangesi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand2),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:761 */
rtx
gen_atomic_fetch_addsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_PLUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:761 */
rtx
gen_atomic_fetch_subsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:761 */
rtx
gen_atomic_fetch_orsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_IOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:761 */
rtx
gen_atomic_fetch_xorsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_XOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:761 */
rtx
gen_atomic_fetch_andsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:791 */
rtx
gen_atomic_fetch_notsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_addqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_subqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_orqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_xorqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_andqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_addhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_subhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_orhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_xorhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:820 */
rtx
gen_atomic_fetch_andhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_addqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_subqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_orqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_xorqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_andqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_addhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_subhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_orhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_xorhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:852 */
rtx
gen_atomic_fetch_andhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_addqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_subqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_orqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_xorqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_andqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_addhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_subhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_orhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_xorhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:889 */
rtx
gen_atomic_andhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_addqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_subqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_orqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_xorqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_andqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_addhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_subhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_orhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_xorhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:911 */
rtx
gen_atomic_andhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1)),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:941 */
rtx
gen_atomic_fetch_notqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:941 */
rtx
gen_atomic_fetch_nothi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:981 */
rtx
gen_atomic_notqi_hard (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:981 */
rtx
gen_atomic_nothi_hard (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_addqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_subqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_orqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_xorqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_andqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_addhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_subhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_orhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_xorhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_andhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_addsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_PLUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_subsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_orsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_IOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_xorsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_XOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1006 */
rtx
gen_atomic_fetch_andsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1041 */
rtx
gen_atomic_fetch_notqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1041 */
rtx
gen_atomic_fetch_nothi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1041 */
rtx
gen_atomic_fetch_notsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_addqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_subqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_orqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_xorqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_andqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_addhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_subhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_orhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_xorhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_andhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_addsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_PLUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_subsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_orsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_IOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_xorsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_XOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1069 */
rtx
gen_atomic_fetch_andsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_addqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_subqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_orqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_xorqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_andqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_addhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_subhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_orhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_xorhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_andhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_addsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_PLUS (SImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_subsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_orsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_IOR (SImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_xorsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_XOR (SImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1104 */
rtx
gen_atomic_andsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	copy_rtx (operand0),
	operand1)),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1130 */
rtx
gen_atomic_fetch_notqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1130 */
rtx
gen_atomic_fetch_nothi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1130 */
rtx
gen_atomic_fetch_notsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	copy_rtx (operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1159 */
rtx
gen_atomic_notqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	copy_rtx (operand0))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1159 */
rtx
gen_atomic_nothi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	copy_rtx (operand0))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1159 */
rtx
gen_atomic_notsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	copy_rtx (operand0))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_addqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_PLUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_subqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_MINUS (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_orqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_IOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_xorqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_XOR (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_andqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_addhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_PLUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_subhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_MINUS (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_orhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_IOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_xorhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_XOR (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_andhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_addsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_PLUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_subsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_orsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_IOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_xorsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_XOR (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1179 */
rtx
gen_atomic_fetch_andsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2)),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1213 */
rtx
gen_atomic_fetch_notqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	copy_rtx (operand1))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode))));
}

/* ../../gcc/config/sh/sync.md:1213 */
rtx
gen_atomic_fetch_nothi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	copy_rtx (operand1))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ../../gcc/config/sh/sync.md:1213 */
rtx
gen_atomic_fetch_notsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	copy_rtx (operand1))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1282 */
rtx
gen_atomic_fetch_nandsi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:1316 */
rtx
gen_atomic_fetch_nandqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:1316 */
rtx
gen_atomic_fetch_nandhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:1349 */
rtx
gen_atomic_fetch_nandqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (QImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand1)),
	operand2))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1349 */
rtx
gen_atomic_fetch_nandhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (HImode,
	operand1)),
		gen_rtx_SET (gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand1)),
	operand2))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1386 */
rtx
gen_atomic_nandqi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	operand1))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:1386 */
rtx
gen_atomic_nandhi_hard (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand0),
	operand1))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0)));
}

/* ../../gcc/config/sh/sync.md:1408 */
rtx
gen_atomic_nandqi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (QImode,
	operand0),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	gen_rtx_MEM (QImode,
	copy_rtx (operand0)),
	operand1))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1408 */
rtx
gen_atomic_nandhi_hard_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (gen_rtx_MEM (HImode,
	operand0),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	gen_rtx_MEM (HImode,
	copy_rtx (operand0)),
	operand1))),
	33)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	147),
	const1_rtx),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1437 */
rtx
gen_atomic_fetch_nandqi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1437 */
rtx
gen_atomic_fetch_nandhi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1437 */
rtx
gen_atomic_fetch_nandsi_soft_gusa (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode)),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1471 */
rtx
gen_atomic_fetch_nandqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1471 */
rtx
gen_atomic_fetch_nandhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1471 */
rtx
gen_atomic_fetch_nandsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1506 */
rtx
gen_atomic_nandqi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand0),
	operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1506 */
rtx
gen_atomic_nandhi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand0),
	operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1506 */
rtx
gen_atomic_nandsi_soft_tcb (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand0),
	operand1))),
	33)),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1)));
}

/* ../../gcc/config/sh/sync.md:1531 */
rtx
gen_atomic_fetch_nandqi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (QImode,
	gen_rtvec (1,
		gen_rtx_NOT (QImode,
	gen_rtx_AND (QImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1531 */
rtx
gen_atomic_fetch_nandhi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		gen_rtx_NOT (HImode,
	gen_rtx_AND (HImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc/config/sh/sync.md:1531 */
rtx
gen_atomic_fetch_nandsi_soft_imask (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (4,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_NOT (SImode,
	gen_rtx_AND (SImode,
	copy_rtx (operand1),
	operand2))),
	33)),
		gen_hard_reg_clobber (SImode, 0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

